require_relative './helper'

class TestEnvironment < Test::Unit::TestCase

  def eval(text)
    Aster::Environment.new.eval(text)
  end

  def test_not
    e = Aster::Environment.new
    assert_equal "no", e.eval("not yes")
    assert_equal "yes", e.eval("not no")
  end

  def test_sub_not
    e = Aster::Environment.new
    assert_equal "no", e.eval("not {not no}")
    assert_equal "yes", e.eval("not {not {not no}}")
  end

  def test_equal
    e = Aster::Environment.new
    assert_equal "yes", e.eval("equal 1 1")
    assert_equal "yes", e.eval("equal {not no} yes")
  end

  def test_add
    assert_equal "12", eval("add 6 6")
    assert_equal "6", eval("add 1 2 3")
    assert_equal "12", eval("add 1 2 3 {add 3 3}")
  end

  def test_set
    e = Aster::Environment.new
    e.eval "set key value"
    e.eval "set whatev 22"
    assert_equal "yes", e.eval("equal value $key")
    assert_equal "yes", e.eval("equal $whatev {add 2 10 10}")
  end

  def test_function
    e = Aster::Environment.new
    e.eval "function test arg1 arg2\n  echo $arg1 and $arg2"
    e.eval "test one two"
    assert_equal("one and two", e.stdout)
  end

  def test_if
    e = Aster::Environment.new
    e.eval "if yes\n  echo test"
    assert_equal e.stdout, "test"
  end

  def test_macro
    e = Aster::Environment.new
    e.define_macro :double do |c|
      assert_kind_of Aster::Command, c
      tree = Aster::Parser.new.parse("add #{c.arguments.first} #{c.arguments.first}")
      tree.first
    end
    assert_equal "32", e.eval("double 16")
  end

  def test_env


  end

end